class PyHalebardeException(Exception):
    def __init__(self):
        self.value = "standard pyhalebarde exception, this message should never\
                appear"

    def __str__(self):
        return repr(self.value)

class CaseNotEmpty(PyHalebardeException):
    def __init__(self, x, y):
        self.value = "cannot add unit, the case isn't free: (%i, %i)" % (x, y)

class CaseIsEmpty(PyHalebardeException):
    def __init__(self, x, y):
        self.value = "cannot remove unit, the case is already empty: (%i, %i)"\
                % (x, y)

class BaseIsAnormalyFull(PyHalebardeException):
    def __init__(self): "cannot return to base, base is anormaly full"

class NothingSelected(PyHalebardeException):
    def __init__(self):
        self.value = "cannot cancel, nothing is selected"

def is_in_black_base(x, y):
    return y >= 0 and y < BASE_H and\
        x >= BLACK_X and x < BLACK_XW

def is_in_white_base(x, y):
    return y >= 0 and y < BASE_H and\
        x >= WHITE_X and x < WHITE_XW

def is_in_battlefield(x, y):
    return y >= 0 and y < BASE_H and\
        x >= BATTLEFIELD_X and x < BATTLEFIELD_XW

def position_is_valid(x, y):
    """Check if position actually correspond to a case on the board"""

    return is_in_black_base(x, y) or\
            is_in_white_base(x, y) or\
            is_in_battlefield(x, y)


HILLS = [(6, 0), (8, 0), (11, 0), (15, 0), (18, 0), (20, 0), (6, 5),
    (8, 5), (11, 5), (15, 5), (18, 5), (20, 5), (9, 2), (9, 3), (10, 2),
    (10, 3), (13, 2), (13, 3), (16, 2), (16, 3), (17, 2), (17, 3)]


BLACK_BASE_ENTRY = [(20, y) for y in range(0, 6)]
WHITE_BASE_ENTRY = [(6, y) for y in range(0, 6)]

TOTAL_WIDTH = 29
TOTAL_HEIGHT = 8

RIGHT_MOUSE_BUTTON = 3
LEFT_MOUSE_BUTTON = 1

EMPTY = 0

NUMBER_OF_SABOTEUR_PLACE = 4

FIRST_TURN = 1
TURN = 1

MAX_PLAYABLE_UNIT_TYPE = 2

BASE_W = 5
BASE_H = 6

WHITE_X = 0
WHITE_Y = 0
WHITE_W = BASE_W
WHITE_H = BASE_H
WHITE_XW = WHITE_X + WHITE_W
WHITE_YH = WHITE_Y + WHITE_H
WHITE_DIM = (WHITE_X, WHITE_Y, WHITE_W, WHITE_H)

BLACK_X = 22
BLACK_Y = 0
BLACK_W = BASE_W
BLACK_H = BASE_H
BLACK_XW = BLACK_X + BLACK_W
BLACK_YH = BLACK_Y + BLACK_H
BLACK_DIM = (BLACK_X, BLACK_Y, BLACK_XW , BLACK_YH)

BATTLEFIELD_X = 6
BATTLEFIELD_Y = 0
BATTLEFIELD_W = 15
BATTLEFIELD_H = 6
BATTLEFIELD_XW = BATTLEFIELD_X + BATTLEFIELD_W
BATTLEFIELD_YH = BATTLEFIELD_Y + BATTLEFIELD_H
BATTLEFIELD_DIM = (BATTLEFIELD_X, BATTLEFIELD_Y, BATTLEFIELD_XW,\
        BATTLEFIELD_YH)

DEV_DATA_DIR = "data"
DATA_SUBDIR = "../share/games/pyhalebarde"
DATA_PATH = '.' #Should be changed by a call to util.set_data_path_from_bin_path
