import gtk
import gtk.gdk
import contact_manager
from util import find_file

class InviteDialog:
    def __init__(self):
        self.contact = None
        builder = gtk.Builder()
        builder.add_from_file(find_file("invite_dialog.ui"))
        builder.connect_signals(self)
        self.window = builder.get_object("invite_dialog")
        #self.avatar_image = builder.get_object("avatar_image")
        #self.avatar_image.set_from_icon_name(\
            #'stock_person', gtk.ICON_SIZE_BUTTON)
        self.status_label = builder.get_object("status_label")

        box = builder.get_object('chooser_box')

        manager = contact_manager.ContactManager()
        combobox = gtk.ComboBox(manager)
        cell = gtk.CellRendererText()
        combobox.pack_start(cell, True)
        combobox.add_attribute(cell, 'text', 2)  
        combobox.show()
        
        combobox.connect('changed', self.on_changed)

        box.pack_start(combobox)

    def run(self):
        rep = self.window.run()
        self.window.hide()
        if rep == gtk.RESPONSE_OK:
            return self.contact
        else:
            return None

    def on_changed(self, sender):
        #get selection
        active = sender.get_active()
        if active == -1:
            return

        #get model
        model = sender.get_model()

        #get iter representing choice
        iter =  model.get_iter(active)

        # Set the status
        status = model.get_value(iter, 4)
        if not status:
            status = ''
        self.status_label.set_text(status)

        
        self.contact = model.get_value(iter, 0), model.get_value(iter, 5).conn

if __name__ == "__main__":
    dialog = InviteDialog()
    print dialog.run()

