application = "pyhalebarde"

# i18n
import gettext
gettext.install(application, unicode=1)

try:
    # For python < 2.6
    from json import read as jsonread
except ImportError:
    # For python 2.6 (json module in python 2.6 is simpejson not json-py)
    from json import loads as jsonread
except Exception:
    print Exception
    print _("\n*** error while importing json, are they install on your system\
    ?  ***")
    print _("'apt-get install python-json' for debian based distribution")

import globals
import sys, os.path


DATA_DIRS = [".", "/usr/share/games/pyhalebarde",
        os.path.expanduser("~/.data/pyhalebarde")]

class Theme:
    """Graphical Theme"""

    def __init__ (self, theme):
        self.read_theme(theme)

    def load_units_graphisms(self):
        """Load the graphisms for the units from the theme, MUST be done after
        initializing the pygame screen or it will fail"""

        self.g = {"Soldier" : {}, "Archer" : {}, "Saboteur" : {}}
        # TODO comment
        for u in ["Soldier", "Archer", "Saboteur"]:
            for team in ["Black", "White"]:
                self.g[u][team] = self.theme_path + self.t[u][team]["file"]
                #self.g[u][team] = pygame.image.load(self.theme_path +
                        #self.t[u][team]["file"]).convert_alpha()

    def image_source(self, unit, team):
        "return the graphisme of the unit"
        return self.g[unit][team]

    def image_position(self, unit, team):
        return self.t[unit][team]["pos"]

    def read_theme(self, theme):
        "read and load the the theme of the game"

        # TODO comment
        for data_dir in DATA_DIRS:
            self.theme_path = "%s/themes/%s/" % (data_dir, theme)
            theme_filename = self.theme_path + "theme.config"
            if os.path.exists(theme_filename) : break

        print theme_filename
        try:
            theme_file = file(theme_filename).read()
        except IOError:
            raise IOError, _("Error while loading the theme: ") + theme +\
                    _("\nBad argument or file missing/corrupt ?")

        t = self.t = jsonread(theme_file)

        self.case = t['case_size']
        self.screen_size =  (globals.TOTAL_WIDTH* self.case,
                globals.TOTAL_HEIGHT * self.case)
        self.background_color = t['background_color']
        self.mark_color = t['mark_color']
        self.grid_color = t['grid_color']


