from theme import Theme
import sys, os.path, gobject, util
import gamewindow
import gtk

application = "pyhalebarde"

# i18n
import gettext
gettext.install(application, unicode=1)

import tp

TUBE_SERVICE = "org.pygame.Pyhalebarde"

class UI:
    "Graphical interface for the game"
    def __init__(self, theme_name, handler):
        #Load the theme
        self.theme_name = theme_name
        self.theme = Theme(theme_name)
        self.theme.load_units_graphisms()

        self.open_windows = {}

        #open a new game windows by default if not called as a handler
        if not handler:
            # If we are called with --handler we won't open a new windows
            # otherwhise the user will have the game open with 2 windows at
            # the start
            self.new_game_window()
        self.name, self.handler = tp.create_handler(TUBE_SERVICE)

    def new_game_window(self, game = None, side = None, tube = None):
        w = gamewindow.GameWindow(self.theme, game, side, tube)
        self.open_windows[w.window] = w
        w.window.connect('destroy', self.on_game_window_closed)

        return w

    def on_game_window_closed(self, sender):
        del self.open_windows[sender]
        if len(self.open_windows) == 0:
            gtk.main_quit()

    def create_welcome(self):
        "Create a Welcome screen for the player"
        # TODO again : Somehow display the text
        """Welcome to pyHalebarde.
            Objective: Place your 4 saboteurs in the enemy base.
            Press Enter to end your turn.
            Clic !"""

ui = None

def get_ui(theme_name = None, handler = None):
    global ui
    if not ui:
        ui =  UI(theme_name, handler)
    return ui

