#!/usr/bin/python
# -*- coding:Utf-8 -*-

import units
import unittest

import game

class UnitTest(unittest.TestCase):

    def test_unit_as_0_speed(self):
        "Unit template class has no speed"
        self.unit = units.Unit()
        self.assertEqual(0, self.unit.SPEED)

class ArcherTest(unittest.TestCase):

    def test_archer_as_0_speed(self):
        "Archer has no speed"
        self.archer = units.Archer()
        self.assertEqual(0, self.archer.SPEED)

    def test_archer_can_t_go_on_hills(self):
        "archer can go on hills"
        self.archer = units.Archer()
        self.assertEqual(True, self.archer.CAN_GO_ON_HILLS)

class SoldierTest(unittest.TestCase):

    def test_soldier_as_a_speed_of_3(self):
        "Soldier has speed of 3"
        self.soldier = units.Soldier()
        self.assertEqual(3, self.soldier.SPEED)

    def test_soldier_can_t_go_on_hills(self):
        "soldier can go on hills"
        self.soldier = units.Soldier()
        self.assertEqual(True, self.soldier.CAN_GO_ON_HILLS)

class SaboteurTest(unittest.TestCase):

    def test_can_attack_from(self):
        """ Saboteur can't attack (return a [] of possibility)"""
        self.saboteur = units.Saboteur()
        self.test_board = game.Board(5, 6)
        self.assertEqual([], self.saboteur.can_attack_from(0, 0,
            self.test_board))

    def test_saboteur_as_a_speed_of_2(self):
        "Saboter has speed of 2"
        self.saboteur = units.Saboteur()
        self.assertEqual(2, self.saboteur.SPEED)

    def test_saboteur_can_t_go_on_hills(self):
        "Saboteur can't go on hills"
        self.saboteur = units.Saboteur()
        self.assertEqual(False, self.saboteur.CAN_GO_ON_HILLS)

if __name__ == "__main__":
    unittest.main()

# vim:set shiftwidth=4 tabstop=4 expandtab textwidth=79:
