import os.path
import logging
import globals
logger = logging.getLogger('halebarde.util')

def change_process_name(process_name):
    """change process name for killall"""
    try:
       import ctypes
       libc = ctypes.CDLL('libc.so.6')
       libc.prctl(15, process_name, 0, 0, 0)
    except Exception, e:
       logger.warning('Unable to set processName: %s" % e')

def activate_psyco():
    """activate psyco_ support to make the game faster

    .. _psyco:http://psyco.sourceforge.net/
    """

    try:
        logger.info("Activating psyco support")
        import psyco
        psyco.full()
    except ImportError, error:
        logger.warning("Psyco isn't installed on your system.")
        logger.warning("Installing it could make the game run a little bit faster.")

def find_file(filename):
    dev_file = os.path.abspath(os.path.join(globals.DEV_DATA_DIR, filename))
    if os.path.isfile(dev_file):
        path = dev_file
    else:
        path = os.path.join(globals.DATA_PATH, filename)
    
    logging.debug("Using file %s" % (path))
    return path


def set_data_path_from_bin_path(path):
    "Try to guess at run time the system wide data path"
    # Set the system wide data path assuming that if the bin is in
    # $prefix/bin or $prefix/games
    # data will be in ../share/games/pyhalebarde
    # If the game is not installed we will fallback to the
    # Dev data dir in find_file
    bindir = os.path.abspath(os.path.dirname(path))
    datapath = os.path.normpath(os.path.join(bindir, globals.DATA_SUBDIR))
    globals.DATA_PATH = datapath
 
# vim:set shiftwidth=4 tabstop=4 expandtab textwidth=79:
